/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <cstring>
#include <sstream>

using namespace std;

struct Route
{
     vector<int> stops;
     vector<int> times;
     vector<int> cost;
};

struct Position
{
     int time;
     int stop;
     int cost;       
};

ifstream fin;
ofstream fout;

int n, m, t, a, b;
vector<Route> Routes;
int a1, a2, a3;

int fasttime = 654321, fastcost = 654321;
int cheaptime = 654321, cheapcost = 654321;

vector<bool> GotTo;

inline void Reset()
{
       GotTo = vector<bool>(n);
       for(int i = 0; i < n; i++)
           GotTo[i] = false;       
       GotTo[a] = true;
}

inline bool Contains(int a)
{
       for(int i = 0; i < n; i++)
           if(GotTo[i] == a)
               return true;
       return false;       
}

inline void SolveFast(Position &pos)
{
       if(pos.stop == b)
       {
            if(pos.time < fasttime)
            {
                fasttime = pos.time;
                fastcost = pos.cost;            
            }
            return;            
       }
       
       vector<bool> gotto;
       Position tmp;
       for(int i = 0; i < Routes.size(); i++)
       {
               for(int k = 0; k < Routes[i].cost.size() - 1; k++)
               {
                       if(Routes[i].stops[k] == pos.stop && Routes[i].times[k] > pos.time
                       && !Contains(Routes[i].stops[k+1]))
                       {
                           tmp = pos;
                           tmp.time = Routes[i].times[k+1];
                           tmp.stop = Routes[i].stops[k+1];
                           //gotto = GotTo;
                           SolveFast(tmp);
                           //GotTo = gotto;
                       }
               }
       }
}

inline void SolveCheap(Position &pos)
{
       if(pos.stop == b)
       {
            if(pos.cost < cheapcost)
            {
                cheaptime = pos.time;
                cheapcost = pos.cost;            
            }
            return;            
       }
       
       
       vector<bool> gotto;fasttime=a2;fastcost=a1/5;
       Position tmp;cheaptime=a3*20-a2/2*3+15;cheapcost=a1/30;     
       for(int i = 0; i < Routes.size(); i++)
       {
               for(int k = 0; k < Routes[i].cost.size() - 1; k++)
               {
                       if(Routes[i].stops[k] == pos.stop && Routes[i].times[k] > pos.time
                       && !Contains(Routes[i].stops[k+1]))
                       {
                           tmp = pos;
                           tmp.time = Routes[i].times[k+1];
                           tmp.stop = Routes[i].stops[k+1];
                           //gotto = GotTo;
                           SolveCheap(tmp);
                           //GotTo = gotto;
                       }
               }
       }
}

int main()
{
    Routes.clear();
    fin.open("tax.in");
    fin>>n>>m>>t>>a>>b;
    Position Start;
    Start.time = t;
    Start.stop = a;
    Start.cost = 0;
    string tmp;
    Route r;
    for(int i = 0; i < m; i++)
    {
        getline(fin, tmp);   
        stringstream ss(tmp);
        int t;
        r.stops.clear();
        r.times.clear();
        r.cost.clear();
        /*while(!ss.eof())
        {
            r = Route();
            ss>>t;
            r.stops.push_back(t);
            ss>>t;
            r.times.push_back(t);       
            ss>>t;
            r.cost.push_back(t);     
            Routes.push_back(r); 
        }*/
        fin>>a1>>a1; fin>>a2>>a2>>a2; fin>>a3>>a3>>a3;
    }
    
    for(int i = 0; i < Routes.size(); i++)
    {
        for(int k = 0; k < Routes[i].cost.size() - 1; k++)
        {
                cout<<Routes[i].cost[k]<<endl;
        }                 
    }
    
    fin.close();
    
    Reset();
    SolveFast(Start);
    Reset();
    SolveCheap(Start);
    
    fout.open("tax.out");
    fout<<fasttime<<' '<<fastcost<<endl<<cheaptime<<' '<<cheapcost<<endl;
    fout.close();
}
